#include <sys/time.h>

#define FILE_MAX 256

struct USERINFO {
 char		name[24];  // Username
 unsigned long	bytes;     // Bytes uploaded
 double		speed;     // Time spent uploading (secs)
 short		files,     // Files uploaded
		pos,       // User position
		group;     // Primary group number
};


struct GROUPINFO {
 char		name[24];  // Groupname
 unsigned long	bytes;     // Bytes uploaded
 double		speed;     // Time spent uploading (secs)
 short		files,     // Files uploaded
		pos,       // Group position
		users;     // Users in group;
};



struct MP3TAGS {
 char artist[31],
      title[31],
      album[31],
      genre[31],
      year[5],
      bitrate[5];
};


struct VARS {
 char	*user,
	user_group	[24], 
	old_leader	[24],
	*release_name,
	top_messages [2][1024],
	racer_list	[1024],
	error_msg	[80],
	progress_bar	[15],
	compression_method,
	*fname;

 long	speed;
 double	total_speed;

 unsigned long	total_size,
		file_size,
		total_bad_size;

 short	write_log,
	user_pos,
	users,
	groups,
	missing_files, 
	total_files,
	total_bad_files,
	release_type,
	error_code,
	fastest_user[2],
	slowest_user[2];

 struct	timeval	transfer_start,
		transfer_stop;
 struct MP3TAGS mp3info;
};


struct LOCATIONS {
 char	*leader,
	*incomplete,
	*sfv,
	*race,
	*link_target,
	*link_source,
	*filename,
	*path;
 int	length_path,
	length_zipdatadir;
};

#define F_BAD           -1
#define F_DELETED        0
#define F_CHECKED        1
#define F_NOTCHECKED     2
